package configManager;

import javax.swing.JLabel;
import java.awt.Color;
import javax.swing.ListCellRenderer ;
import java.awt.Component;
import javax.swing.JList;
import ui.ConfigurationsListItem;

class ConfigListCellRenderer extends JLabel implements ListCellRenderer {

     public ConfigListCellRenderer() {
         setOpaque(true);
     }

     public Component getListCellRendererComponent(JList list,
                                                   Object value,
                                                   int index,
                                                   boolean isSelected,
                                                   boolean cellHasFocus) {

	 ConfigurationsListItem cli = (ConfigurationsListItem) value;
	 setText("["+((cli.getIsSystem())?('S'):('u'))+"]"+
		 cli.getName()+" || "+
		 cli.getFilename());

         Color background;
         Color foreground;
	 
	 if (isSelected) {
             background = Color.RED;
             foreground = Color.WHITE;
         } else {
             background = Color.WHITE;
             foreground = Color.BLACK;
         };

         setBackground(background);
         setForeground(foreground);

         return this;
     }
 }
 