package configManager;

import nat.ConfigNat;
import configManager.ConfigManagerFrame;
import java.util.ArrayList;
import java.io.File;
import java.util.Collections;
import java.util.ArrayList;
import ui.ConfigurationsListItem;
import gestionnaires.GestionnaireErreur;
import java.io.IOException;

public class ConfigManager 
{     
    static public ArrayList<ConfigurationsListItem> chargeConfigurations()
    {
	
        File repertoireSysteme = new File(ConfigNat.getSystemConfigFilterFolder());
        File repertoireUser   = new File(ConfigNat.getUserConfigFilterFolder());   
        ArrayList<File> both = new ArrayList<File>();                        
	
        try {
	    Collections.addAll(both,repertoireSysteme.listFiles());
	} catch (NullPointerException npe){
	    npe.printStackTrace();
	}                                                          
	
        try {
	    Collections.addAll(both, repertoireUser.listFiles());
	} catch (NullPointerException npe){
	    npe.printStackTrace();
	}                                                        
	
	File[] listConfs = both.toArray(new File[] {});
	ArrayList<ConfigurationsListItem> lesConfs=  new ArrayList<ConfigurationsListItem>();

	GestionnaireErreur gestErreur = new GestionnaireErreur(null,1);
	for (File f : listConfs){
	    try {
		ConfigurationsListItem cli = new ConfigurationsListItem(f.getCanonicalPath(), gestErreur);
		if (cli.getIsValid()){
		    lesConfs.add(cli);
		}
	    } catch (IOException e){
		e.printStackTrace();
	    }
	    
	}
	Collections.sort(lesConfs);
	return lesConfs;
    }
    public void rImport(File[] files) {
	for(File f: files){
	    
	}	
    }
    public void rExport(Object[] selected) {
	for(Object o: selected){
	    ConfigurationsListItem cli = (ConfigurationsListItem) o;
	    System.out.println(cli.getName());
	}	
    }
    public void rEnableSelectedInNat(Object[] selected) {
	for(Object o: selected){
	    ConfigurationsListItem cli = (ConfigurationsListItem) o;
	    System.out.println(cli.getName());
	}	
    }
    public void rDisableSelectedInNat(Object[] selected) {
	for(Object o: selected){
	    ConfigurationsListItem cli = (ConfigurationsListItem) o;
	    System.out.println(cli.getName());
	}	
    }
    public void rCopy(Object[] selected) {
	for(Object o: selected){
	    ConfigurationsListItem cli = (ConfigurationsListItem) o;
	    System.out.println(cli.getName());
	}	
    }
    public void rDelete(Object[] selected) {
	for(Object o: selected){
	    ConfigurationsListItem cli = (ConfigurationsListItem) o;
	    System.out.println(cli.getName());
	}	
    }
    

    public static void main(String[] argv){
	ConfigManager cm = new ConfigManager();
	ConfigManagerFrame cf = new ConfigManagerFrame(cm);
	cf.updateList();
	cf.setVisible(true);
    }
}