package configManager;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JList;
import javax.swing.JTable;
import nat.ConfigNat;
import ui.ConfigurationsListItem;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.nio.charset.Charset;
import java.util.Collections;
import java.util.ArrayList;
import java.util.Properties;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;

import gestionnaires.GestionnaireErreur;
import ui.ConfigurationsComboBoxRenderer;

import java.awt.Component;
import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Color;

import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import configManager.ConfigManager;
import configManager.ConfigListCellRenderer;
import javax.swing.DefaultListModel;

import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;

public class ConfigManagerFrame  extends JFrame   implements ActionListener {

    private DefaultListModel model = new DefaultListModel(); 
    private JList list = new JList();
    private JButton btExit = new JButton("exit");
    private JButton btImport = new JButton("import");
    private JButton btExportSelected = new JButton("export");
    private JButton btEnableSelectedInNat = new JButton("enable");
    private JButton btDisableSelectedInNat = new JButton("disable");
    private JButton btCopySelected = new JButton("copy");
    private JButton btDeleteSelected = new JButton("delete");
    private ConfigManager configManager = null;
    
    public ConfigManagerFrame(ConfigManager cm){
	super();
	configManager = cm;
	build();
    }
    
    public void updateList(){
	ArrayList<ConfigurationsListItem> zob = configManager.chargeConfigurations();
	model.clear(); 
	ConfigurationsListItem[] totem = new ConfigurationsListItem[zob.size()];
	for (int i=0;i<zob.size();i++){
	    ConfigurationsListItem a =  zob.get(i);	   
	    totem[i] = zob.get(i);
	    model.add(i, zob.get(i)); 
	}
    }

    private void build(){   
	
	setTitle("Nat Configuration Manager"); 
	setSize(500,520); 
	setLocationRelativeTo(null);
	

	GridBagLayout gridbag = new GridBagLayout();
	setLayout(gridbag);
	GridBagConstraints c = new GridBagConstraints(0,GridBagConstraints.RELATIVE,1,4,0,0,
						      GridBagConstraints.CENTER,
						      GridBagConstraints.NONE, //HORIZONTAL,
						      new Insets(0, 0, 0, 0),0,0);
	// haut
	JPanel panelHaut = new JPanel();
	panelHaut.add(btImport);
	add(panelHaut,c);
	
	// milieu
	c.fill = GridBagConstraints.BOTH;
	c.weightx = 10;
	c.weighty = 10;

	list.setModel(model); 
	list.setCellRenderer(new ConfigListCellRenderer());
	add(new JScrollPane(list),c);

	// milieubas       
	JPanel panelMilieuBas = new JPanel();
	c.fill = GridBagConstraints.NONE;
	c.weightx = 1;
	c.weighty = 1;
	panelMilieuBas.add(btExportSelected);
	panelMilieuBas.add(btEnableSelectedInNat);
	panelMilieuBas.add(btDisableSelectedInNat);
	panelMilieuBas.add(btCopySelected);
	panelMilieuBas.add(btDeleteSelected);
	add(panelMilieuBas,c);

	// bas
	JPanel panelBas = new JPanel();
	panelBas.add(btExit);
	add(panelBas,c);

	btExit.addActionListener(this);
	btImport.addActionListener(this);
	btExportSelected.addActionListener(this);
	btEnableSelectedInNat.addActionListener(this);
	btDisableSelectedInNat.addActionListener(this);
	btCopySelected.addActionListener(this);
	btDeleteSelected.addActionListener(this);
    }

    private File[] selectFiles(){
	JFileChooser chooser = new JFileChooser();
	int returnVal = chooser.showOpenDialog(this);
	if(returnVal == JFileChooser.APPROVE_OPTION) {
	    return chooser.getSelectedFiles();
	} else {
	    return null;
	}
    }
 
    public void actionPerformed(ActionEvent evt){
	if (evt.getSource() == btExit){ 
	    System.exit(1);
	} else if (evt.getSource() == btImport){
	    configManager.rImport(selectFiles());
	    updateList();
	} else if (evt.getSource() == btExportSelected){
	    configManager.rExport(list.getSelectedValues());
	    updateList();
	} else if (evt.getSource() == btEnableSelectedInNat){	  
	    configManager.rEnableSelectedInNat(list.getSelectedValues());
	    updateList();
	} else if (evt.getSource() == btDisableSelectedInNat){	    
	    configManager.rDisableSelectedInNat(list.getSelectedValues());
	    updateList();
	} else if (evt.getSource() == btCopySelected){	   
	    configManager.rCopy(list.getSelectedValues());
	    updateList();
	} else if (evt.getSource() == btDeleteSelected){	 
	    configManager.rDelete(list.getSelectedValues());
	    updateList();
	} else {
	    System.out.println("what you wante.");
	}
    }
}
