;NSIS Modern User Interface
;Basic Example Script
;Written by Joost Verburg

;--------------------------------
;Include Modern UI

!include "MUI2.nsh"
!include "FontReg.nsh"
!include "FontName.nsh"
!include "WordFunc.nsh"

;--------------------------------
;General

  ;Details montres
  ShowInstDetails show
  
  ;Name and file
  Name "Nat"
  OutFile "Nat installer.exe"

  ;Default installation folder
  InstallDir "$PROGRAMFILES\Nat"
  
  ;Get installation folder from registry if available
  InstallDirRegKey HKCU "Software\Nat" ""

  ;Request application privileges for Windows Vista
  RequestExecutionLevel admin

;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING

;--------------------------------
;Pages

  !insertmacro MUI_PAGE_LICENSE "..\..\licence.txt"
  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "French"

;--------------------------------
;Installer Sections

Section "Nat" SecMain

	;--------------------------------
	;Question pour la suite de l'install

	MessageBox MB_YESNO "Des non-voyants vont-ils utiliser cette installation de NAT ?" IDYES true1 IDNO false1
	true1:
	  StrCpy $R2 "aveugle"
	  Goto next1
	false1:
	  StrCpy $R2 "voyant"
	next1:

  SetOutPath "$INSTDIR\aide"
  File /r /x *.svn "..\..\aide\*.*" 
    
  SetOutPath "$INSTDIR\configurations"	
  File "..\..\configurations\*.cfg"
  File /r /x *.svn "..\..\configurations\abrege"
  
  SetOutPath "$INSTDIR"
  File /r /x *.svn "..\..\*.class"
  File /r /x *.svn "..\..\*.jar"
  File /r /x *.svn "..\..\*.png"
  File /r /x *.svn "..\..\*.au"
  File /r /x *.svn "..\..\*.ttf"
  File /r /x *.svn "..\..\*.txt"
  
  SetOutPath "$INSTDIR\writer2latex"
  File /r "..\..\writer2latex\*.xml"
  
  SetOutPath "$INSTDIR\xsl"
  File /r /x *.svn "..\..\xsl\*.*" 

  SetOutPath "$INSTDIR\tmp"   
  File "..\..\licence.txt"
  
  SetOutPath "$INSTDIR\documents"
  File /x *.svn "..\..\documents\*.*"

  SetOutPath "$INSTDIR\text"
  File /r /x *.svn "..\..\text\*.properties"
  
  SetOutPath "$INSTDIR\gnu\getopt"
  File /r /x *.svn "..\..\gnu\getopt\*.properties"

  
  SetOutPath "$INSTDIR"   
  File "..\..\nat-launch-windows.bat"
  File "..\..\licence.txt"
  File "..\..\nat.exe"
  StrCmp $R2 "aveugle" gui_aveugle gui_voyant
  gui_aveugle:
	File "/oname=nat-gui.conf-initial" "..\..\nat-gui.conf-initial-aveugle"
	MessageBox MB_OK "N'oubliez pas d'installer le Java Access Bridge 2.0.1 pour utiliser NAT.$\nCe logiciel est tlchargeable depuis le site trs accessible$\nhttp://sonobraille.free.fr section tlchargement."
	Goto fin_gui
  gui_voyant:
    File "/oname=nat-gui.conf-initial" "..\..\nat-gui.conf-initial-voyant"
  fin_gui:
  
  ;Store installation folder
  WriteRegStr HKCU "Software\Nat" "" $INSTDIR
  
  ;Create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"

  CreateDirectory "$SMPROGRAMS\NAT"
  CreateShortCut "$SMPROGRAMS\NAT\NAT.lnk" "$INSTDIR\nat.exe"
  CreateShortCut "$SMPROGRAMS\NAT\NAT pour gros documents (avec console).lnk" "$INSTDIR\nat-launch-windows.bat"
  CreateShortCut "$SMPROGRAMS\NAT\Supprimer NAT.lnk" "$INSTDIR\Uninstall.exe"
  
SectionEnd

Section "Polices braille" SecPolice
  StrCpy $FONT_DIR $FONTS
 
  !insertmacro RemoveTTFFont 'BrailleTBFr2007INSHEAb_thermo.ttf'
  !insertmacro RemoveTTFFont 'braille_tbfr2007_b.ttf'
  !insertmacro RemoveTTFFont 'braille_tbfr2007_b-2.ttf'
  !insertmacro RemoveTTFFont 'LouisLouis.ttf'
  !insertmacro RemoveTTFFont 'LouisLouisThermo.ttf'
  !insertmacro InstallTTFFont '..\fonts\BrailleTBFr2007INSHEAb_thermo.ttf'
  !insertmacro InstallTTFFont '..\fonts\braille_tbfr2007_b-2.ttf'
  !insertmacro InstallTTFFont '..\fonts\LouisLouis.ttf'
  !insertmacro InstallTTFFont '..\fonts\LouisLouisThermo.ttf'
  
  SendMessage ${HWND_BROADCAST} ${WM_FONTCHANGE} 0 0 /TIMEOUT=5000
SectionEnd

Section "Configurations pour DBT" SecDBT
  ;SetOutPath "$INSTDIR\configurations"	
  ;File "/oname=windows-dbt107.cfg" "..\..\configurations\windows-dbt107.cfg.initial"
  
  ReadRegStr $R1 HKLM "Software\Duxbury Systems, Inc." "LatestDBT"
  StrCmp $R1 "" nondetecte32 detecte
  nondetecte32:
	ReadRegStr $R1 HKLM "Software\Wow6432Node\Duxbury Systems, Inc." "LatestDBT"
  StrCmp $R1 "" nondetecte64 detecte
	nondetecte64:
  MessageBox MB_OK "DBT 10.7 ou suprieur non dtect sur votre systme.$\nLa configuration sera installe mais vous devrez prciser o est DBT dans les options d'interface."
  StrCpy $R1 "Entrez ici le chemin d'accs  DBT 10.7 ou suprieur."
  Goto finDBT
  detecte:
  DetailPrint "DBT dtect ici : $R1"
	${WordReplace} $R1 "\" "\\" "+*" $R3 ; il faut doubler les slash
	DetailPrint $R3
  finDBT:
  ;mise  jour des confs dbt avec le chemin de dbt
  FileOpen $4 "$INSTDIR\configurations\8-windows-dbt107.cfg" a
  FileSeek $4 0 END
  FileWrite $4 "$\r$\n" ; we write a new line
  FileWrite $4 "ui-editor-external="
  FileWrite $4 "$R3"
  FileWrite $4 "$\r$\n" ; we write an extra line
  FileClose $4 ; and close the file
	
	FileOpen $3 "$INSTDIR\configurations\11-mep-dbt107.cfg" a
  FileSeek $3 0 END
  FileWrite $3 "$\r$\n" ; we write a new line
  FileWrite $3 "ui-editor-external="
  FileWrite $3 "$R3"
  FileWrite $3 "$\r$\n" ; we write an extra line
  FileClose $3 ; and close the file
SectionEnd

Section "Intgration  l'explorateur" SecShell
  WriteRegStr HKCR "*\shell\Transcrire avec NAT\command" "" "$\"$INSTDIR\nat-launch-win-gf.bat$\"  $\"%1$\""
  FileOpen $4 "$INSTDIR\nat-launch-win-gf.bat"  w
  FileWrite $4 "@echo OFF$\r$\n"
  FileWrite $4 "set courant=%CD%$\r$\n"
  FileWrite $4 "cd $\"$INSTDIR$\"$\r$\n"
	StrCpy $R5 $INSTDIR 2
	FileWrite $4 "$R5$\r$\n"
  FileWrite $4 "set JAVAOPTIONS=-Xss20000k -Xmx256m -classpath .;lib/jeuclid-core-3.1.9.jar;lib/jeuclid-fop-3.1.9.jar;lib/xercesImpl-2.9.1.jar;lib/commons-io-1.4.jar;lib/jodconverter-2.2.2.jar;lib/jurt-3.0.1.jar;lib/slf4j-api-1.5.6.jar;lib/unoil-3.0.1.jar;lib/juh-3.0.1.jar;lib/ridl-3.0.1.jar;lib/slf4j-jdk14-1.5.6.jar;lib/xstream-1.3.1.jar;lib/jhall.jar;lib/saxon9.jar;lib/saxon9-dom.jar;lib/saxon9he.jar"
  FileWrite $4 "$\r$\n"
  FileWrite  $4 "set FROM=%1$\r$\n"
  FileWrite  $4 "java %JAVAOPTIONS% nat/Nat -g -f %FROM%$\r$\n"
  FileWrite $4 "cd $\"%CD%$\"$\r$\n"
  FileClose $4
SectionEnd

!define MT4_REG_DIR_CONFIG "Software\Design Science\DSMT4\Config"
!define MT5_REG_DIR_CONFIG "Software\Design Science\DSMT5\Config"
!define MT6_REG_DIR_CONFIG "Software\Design Science\DSMT6\Config"
!define REG_KEY_TRANSLATORDIR "TranslatorDir"

!define MT4_REG_DIR_DIRECTORIES "Software\Design Science\DSMT4\Directories"
!define MT5_REG_DIR_DIRECTORIES "Software\Design Science\DSMT5\Directories"
!define MT6_REG_DIR_DIRECTORIES "Software\Design Science\DSMT6\Directories"
!define REG_KEY_PROGDIR "ProgDir"

Function Installezy
;MessageBox MB_OK "installation dans $R0"
SetOutPath "$R0"
File "mathtype\MathML (BraMaNet2).tdl"
FunctionEnd

Section "Convertisseur pour MathType" SecMathType
; mathtype 4

ReadRegStr $R0 HKLM "${MT4_REG_DIR_CONFIG}" "${REG_KEY_TRANSLATORDIR}"
StrCmp $R0 "" mt4_bis
DetailPrint "MathType 4 dtect sur votre systme."
Call Installezy
Goto mt5

mt4_bis:
ReadRegStr $R0 HKLM "${MT4_REG_DIR_DIRECTORIES}" "${REG_KEY_PROGDIR}"
StrCmp $R0 "" mt5
StrCpy $R0 "$R0\Translators"
DetailPrint "MathType 4 dtect sur votre systme."
Call Installezy

; mathtype 5
mt5:
ReadRegStr $R0 HKLM "${MT5_REG_DIR_CONFIG}" "${REG_KEY_TRANSLATORDIR}"
StrCmp $R0 "" mt5_bis
DetailPrint "MathType 5 dtect sur votre systme."
Call Installezy
Goto mt6

mt5_bis:
ReadRegStr $R0 HKLM "${MT5_REG_DIR_DIRECTORIES}" "${REG_KEY_PROGDIR}"
StrCmp $R0 "" mt6
DetailPrint "MathType 5 dtect sur votre systme."
StrCpy $R0 "$R0\Translators"
Call Installezy

; mathtype 6
mt6:
ReadRegStr $R0 HKLM "${MT6_REG_DIR_CONFIG}" "${REG_KEY_TRANSLATORDIR}"
StrCmp $R0 "" mt6_bis
DetailPrint "MathType 6 dtect sur votre systme."
Call Installezy
Goto done

mt6_bis:
ReadRegStr $R0 HKLM "${MT6_REG_DIR_DIRECTORIES}" "${REG_KEY_PROGDIR}"
StrCmp $R0 "" done
DetailPrint "MathType 6 dtect sur votre systme."
StrCpy $R0 "$R0\Translators"
Call Installezy

done:

SectionEnd
Section "Raccourcis sur le bureau" SecRaccourcis

 SetOutPath "$INSTDIR"
 CreateShortCut $DESKTOP\NAT.lnk $INSTDIR\nat.exe   
       
SectionEnd

;--------------------------------
;Descriptions

  ;Language strings
  LangString DESC_SecMain ${LANG_FRENCH} "Programme principal"
  LangString DESC_SecDBT ${LANG_FRENCH} "Configurations spciales pour export vers DBT 10.7 ou plus. Ne fonctionnera pas si DBT 10.7 ou plus n'est pas install."
  LangString DESC_SecPolice ${LANG_FRENCH} "Police LouisLouis (Braille) pour les tables CBFr1252, DuxCBFr1252 et UTF8 ;  Police Braille INSHEA ralise par Marc Ollier (INSHEA) pour la nouvelle table tbfr2007."
  LangString DESC_SecMathType ${LANG_FRENCH} "Convertisseurs vers le MathML pour MathType"
  LangString DESC_SecShell ${LANG_FRENCH} "Ouvrir avec Nat dans le menu contextuel de l'explorateur"
  LangString DESC_SecRaccourcis ${LANG_FRENCH} "Raccourci sur le Bureau"
  

  ;Assign language strings to sections
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SecMain} $(DESC_SecMain)
  !insertmacro MUI_DESCRIPTION_TEXT ${SecDBT} $(DESC_SecDBT)
  !insertmacro MUI_DESCRIPTION_TEXT ${SecPolice} $(DESC_SecPolice)
  !insertmacro MUI_DESCRIPTION_TEXT ${SecRaccourcis} $(DESC_SecRaccourcis)
  !insertmacro MUI_DESCRIPTION_TEXT ${SecMathType} $(DESC_SecMathType)
  !insertmacro MUI_DESCRIPTION_TEXT ${SecShell} $(DESC_SecShell)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------
;Uninstaller Section

Section "Uninstall"

  RMDir /r "$INSTDIR\aide"
  RMDir /r "$INSTDIR\gestionnaires"
  RMDir /r "$INSTDIR\joptsimple"
  RMDir /r "$INSTDIR\nat"
  RMDir /r "$INSTDIR\outils"
  RMDir /r "$INSTDIR\config"
  RMDir /r "$INSTDIR\formula"
  RMDir /r "$INSTDIR\jaxe"
  RMDir /r "$INSTDIR\ui"
  RMDir /r "$INSTDIR\lib"
  RMDir /r "$INSTDIR\tmp"
  RMDir /r "$INSTDIR\writer2latex"
  RMDir /r "$INSTDIR\xsl"
  RMDir /r "$INSTDIR\org"
  RMDir /r "$INSTDIR\configurations"
  RMDir /r "$INSTDIR\winos"
  RMDir /r "$INSTDIR\distrib"
  RMDir /r "$INSTDIR\documents"
  RMDir /r "$INSTDIR\text"
  RMDir /r "$INSTDIR\gnu\getopt"
  RMDir /r "$INSTDIR\gnu"
  RMDir /r "$INSTDIR\doc"
	RMDir /r "$INSTDIR\nonregression"

  
  Delete "$INSTDIR\tmp*.*"
  Delete "$INSTDIR\nat-launch-windows.bat"
	Delete "$INSTDIR\nat-launch-win-gf.bat"
  Delete "$INSTDIR\nat.exe"
  Delete "$INSTDIR\nat-gui.conf-initial"
  Delete "$INSTDIR\licence.txt"
  
  Delete "$DESKTOP\NAT.lnk"
  
  Delete "$INSTDIR\Uninstall.exe"  
  
  DeleteRegKey HKCR "*\shell\Transcrire avec NAT" 
  RMDir /r $SMPROGRAMS\NAT
   
  DeleteRegKey /ifempty HKCU "Software\Nat"
  

SectionEnd
